/*

  Program to test VM by allocating and using large chunks of memory.
  
 */

#include <stdlib.h>
#include <stdio.h>
#include "mtio.h"

#define KB     (1024)
#define MB     (1024*1024)
#define MEGS   (14)
#define MAXMEM ((MEGS)*MB)

#define NUMTESTS 2000

char *blocks[MEGS];

main()
{
    int block, byte;
    
    for (block = 0; block < MEGS; block++) {
	blocks[block] = malloc(MB);
    }

    /* write stuff in each 1KB chunk of each 1MB block */
    for (block = 0; block < MEGS; block++)
	for (byte = 1; byte <MB; byte+=KB) {
	    printf("writing block[%d][%d] @ 0x%x\n", block, byte, &(blocks[block][byte]));
	    blocks[block][byte] = block + 1;
	    printf("+");
	}
    printf("WRITE PART DONE\n");
    
    /* read it to make sure it worked */
    for (block = 0; block < MEGS; block++)
	for (byte = 1; byte <MB; byte+=KB) {
	    printf("reading block[%d][%d] @ 0x%x\n", block, byte, &(blocks[block][byte]));
	    if (blocks[block][byte] != block + 1) {
		printf("UH-OH!!! Something's broken....\n");
		_exit(0);
	    }
	    printf(".");
	}
    printf("READ PART DONE\n");
    
    _exit(0);
}
