/*
  mtio.h

  I/O library for Minithreads programs.  
*/

#ifndef __MTIO_H__
#define __MTIO_H__

#include <stdio.h>

/* Map typical stdio.h calls to mtio calls so we can use minithread system calls */
#define printf  mt_printf
#define fprintf mt_fprintf
#define fflush  mt_fflush

extern int mt_printf(char *fmt, ...);
extern int mt_fprintf(FILE *f, char *fmt, ...);
extern int mt_fflush(FILE *f);

#endif
